<!-- Copyright (C) 2023 Andrew Rechnitzer -->

{% load static %}
<div class="card" style="min-width: fit-content; max-width: 50%; height:100%;">
  <div class="card-body d-flex flex-row p-0">
    {% if has_been_processed %}
    <img 
      src="{% url 'scan_get_image' timestamp 0 %}"
      class="border rounded-start"
      style="max-height: 16em;"
      >
    {% else %}
    <!-- display an animating loading thingy and refresh after a few seconds -->
    <img
      class="shadow-sm p-3 border rounded-start"
      src="{% static 'ball_triangle.svg' %}"
      style="max-height: 14em;"
      hx-get="{% url 'scan_get_staged_bundle_fragment' timestamp %}"
      hw-swap="innerHTML"
      hx-trigger="load delay:2s"
      hx-target="#bundle{{slug}}"
      >
    {% endif %}
    <div class="p-2">
      <h5 class="card-title">{{ slug }}.pdf</h5>
      <p class="card-subtitle">Uploaded {{ when }}</p>
      <ul class="list-unstyled">
        <li>Total pages: {{ number_of_pages }}
	  {% if has_been_processed %}
	  {% else %}
	  Processing pages:
	  <div class="progress" role="progressbar">
	    <div class="progress-bar progress-bar-striped bg-success" style="width: {{percent_split}}%" >{{number_of_split_pages}}</div>
	  </div>
	  {% endif %}
	</li>
	{% if has_been_processed %}
	{% if has_qr_codes %}
	{% if n_known == number_of_pages %}
        <li>Known pages: <i class="bi bi-check-circle text-success"> all</i></li>
	{% else %}
	<li>Known pages: {{ n_known }}</li>
	<li>Extra pages:
	  {% if n_extra %}
	  {% if n_extra == n_extra_w_data %}
	  {{ n_extra }} - all processed <i class="bi bi-check-circle text-success"></i>
	  {% else %} 	  
	  <i class="bi bi-dash-circle-fill text-warning"></i> {{n_extra_w_data}} of {{ n_extra }} processed
	  {% endif %}
	  {% else %} none
	  {% endif %}
	</li>
	<li>Unknown pages:
	  {% if n_unknown %} {{ n_unknown }} <i class="bi bi-question-circle-fill text-warning"></i>
	  {% else %}<i class="bi bi-check-circle text-success"> none</i>
	  {% endif %}
	</li>
	<li>Discard pages:
	  {% if n_discard %} {{ n_discard }}
	  {% else %} none
	  {% endif %}
	</li>

        <li>Error pages:
	  {% if n_errors == 0 %}
	   none  <i class="bi bi-check-circle text-success"></i>
	  {% else %}
	  {{ n_errors}} <i class="bi bi-exclamation-diamond-fill text-danger"></i>
	  {% endif %}
	</li>
	{% endif %}
	{% else %}
	{% if is_mid_qr_read %}
	<li>Reading qr-codes:
	  <div class="progress" role="progressbar">
	    <div class="progress-bar progress-bar-striped bg-success" style="width: {{percent_read}}%" >{{number_of_read_pages}}</div>
	  </div>
	  <img
	    class="shadow-sm p-3 border rounded-start"
	    src="{% static 'ball_triangle.svg' %}"
	    style="max-height: 4em;"
	    hx-get="{% url 'scan_get_staged_bundle_fragment' timestamp %}"
	    hw-swap="innerHTML"
	    hx-trigger="load delay:2s"
	    hx-target="#bundle{{slug}}"
	    >
	</li>
	{% else %}
	<li>QR codes not yet scanned</li>
	{% endif %}
	{% endif %}
	{% endif %}
      </ul>    
    <footer>
      {% if has_been_processed %}
      <a 
        class="btn" 
        href="{% url 'scan_manage_bundle' timestamp 0 %}"
        style="background-color: #0F984F; color: white;"
        >
        View
      </a>
      {% if has_qr_codes %}
      {% if is_perfect %}
      <button
	hx-post="push/{{timestamp}}/all/"
	class="btn btn-warning"
	>Push!</button>
      {% else %}
      <span data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="Cannot push bundle if it contains errors, unknowns, or unprocessed extra-pages">
      <button
	class="btn btn-warning" disabled	
	>Push</button>
      </span>
      {% endif %}      
      {% elif is_mid_qr_read %}
      {% else %}
      <button class="btn btn-info"
	      hx-post="{% url 'scan_get_staged_bundle_fragment' timestamp %}"
	      >Read QR</button>
      {% endif %}
	{% endif %}
      <a 
        class="btn btn-danger {% if bundle.disable_delete %}disabled{% endif %}" 
	hx-delete="{% url 'scan_get_staged_bundle_fragment' timestamp %}"
        hx-confirm="Are you sure?"
        >
        Remove
      </a>
    </footer>
    </div>
  </div>
</div>

<script>
    var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
    var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
        return new bootstrap.Tooltip(tooltipTriggerEl)
    })
</script>
